//
//  SpeakEleAnimation.swift
//  SpeakEasyLearnEnglish
//
//  Created by edy on 2025/7/11.
//

import UIKit

class SpeakCustomPushAnimator: NSObject, UIViewControllerAnimatedTransitioning {
    func transitionDuration(using transitionContext: UIViewControllerContextTransitioning?) -> TimeInterval {
        return 0.35
    }
    
    func animateTransition(using transitionContext: UIViewControllerContextTransitioning) {
        guard let toVC = transitionContext.viewController(forKey: .to),
              let fromVC = transitionContext.viewController(forKey: .from) else { return }
        let containerView = transitionContext.containerView
        containerView.addSubview(toVC.view)
        toVC.view.frame = CGRect(x: 0, y: containerView.bounds.height,
                               width: containerView.bounds.width, height: containerView.bounds.height)
        UIView.animate(withDuration: transitionDuration(using: transitionContext),
                       delay: 0,
                       usingSpringWithDamping: 0.8,
                       initialSpringVelocity: 0.5,
                       options: .curveEaseInOut) {
            toVC.view.frame = containerView.bounds
            fromVC.view.frame = CGRect(x: 0, y: 0,
                                     width: containerView.bounds.width, height: containerView.bounds.height)
        } completion: { finished in
            transitionContext.completeTransition(!transitionContext.transitionWasCancelled)
        }
    }
}

class SpeakCustomPopAnimator: NSObject, UIViewControllerAnimatedTransitioning {
    func transitionDuration(using transitionContext: UIViewControllerContextTransitioning?) -> TimeInterval {
        return 0.35
    }
    
    func animateTransition(using transitionContext: UIViewControllerContextTransitioning) {
        guard let toVC = transitionContext.viewController(forKey: .to),
              let fromVC = transitionContext.viewController(forKey: .from) else { return }
        let containerView = transitionContext.containerView
        containerView.addSubview(toVC.view)
        fromVC.view.frame = CGRect(x: 0, y: 0,
                                   width: containerView.bounds.width, height: containerView.bounds.height)
        
        toVC.view.frame = CGRect(x: 0, y: 0,
                               width: containerView.bounds.width, height: containerView.bounds.height)
        UIView.animate(withDuration: transitionDuration(using: transitionContext),
                       delay: 0,
                       usingSpringWithDamping: 0.8,
                       initialSpringVelocity: 0.5,
                       options: .curveEaseInOut) {
            fromVC.view.frame = CGRect(x: 0, y: containerView.bounds.height,
                                     width: containerView.bounds.width, height: containerView.bounds.height)
        } completion: { finished in
            transitionContext.completeTransition(!transitionContext.transitionWasCancelled)
        }
    }
}
